import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.util.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.media.jai.*;
import javax.media.jai.operator.*;
import com.sun.media.jai.codec.*;
import java.awt.print.*;
import java.awt.geom.*;
import javax.swing.border.*;

public class PicEdit extends JFrame implements ActionListener, Printable {
    private static final int m_BACKGROUND = 0;
    private static final int m_FOREGROUND = 1;

    private JDesktopPane m_desk;
    private PlanarImage m_piBackground;
    private PlanarImage m_piForeground;
    private PlanarImage m_piTmp;
    private ImageDisplay m_idCanvasBack;
    private ImageDisplay m_idCanvasFore;
    private ImageDisplay m_idCanvasZoom;
    private Magnifier m_magZoom;
    private ImageWnd m_iwFore;
    private ZoomWnd m_iwZoom;
    private String m_sPathName;
    private SplashScreen m_ssIntro;

    private JMenuBar m_mbMainMenu;
    private JMenu m_mFile;
    private JMenu m_mEdit;
    private JMenu m_mInfo;

    private JMenuItem m_miBackground;
    private JMenuItem m_miOpen;
    private JMenuItem m_miSave;
    private JMenuItem m_miSaveAs;
    private JMenuItem m_miPrint;
    private JMenuItem m_miExit;
    private JMenuItem m_miScale;
    private JMenuItem m_miInvert;
    private JMenuItem m_miAlpha;
    private JMenuItem m_miBrightnessContrast;
    private JMenuItem m_miSharpSoft;
    private JMenuItem m_miColorChannels;
    private JMenuItem m_miIntensityFilter;
    private JMenuItem m_miZoomSelection;
    private JMenuItem m_miHistogramm;
    private JMenuItem m_miInfo;

    private boolean m_bSave;
    private boolean m_bOpen;

    // Constructor
    public PicEdit(int nWidth, int nHeight) {
        super("PicEdit v1.0b");
        m_ssIntro = new SplashScreen(this);
        m_bSave = true;
        m_bOpen = false;

        this.m_desk = new JDesktopPane();
        m_desk.setDesktopManager(new DefaultDesktopManager());
        setContentPane(m_desk);
        setSize(nWidth, nHeight);

        Color c = new Color(180, 220, 255);
        getContentPane().setBackground(c);

        m_mbMainMenu = new JMenuBar();
        m_mFile = new JMenu("Datei");
        m_mEdit = new JMenu("Bearbeiten");
        m_mInfo = new JMenu("Info");

        m_miBackground = new JMenuItem("Hintergrund...");
        m_miOpen = new JMenuItem("ffnen...");
        m_miSave = new JMenuItem("Speichern...");
        m_miSaveAs = new JMenuItem("Speichern unter...");
        m_miPrint = new JMenuItem("Drucken...");
        m_miExit = new JMenuItem("Beenden");
        m_miScale = new JMenuItem("Skalieren...");
        m_miInvert = new JMenuItem("Invertieren");
        m_miAlpha = new JMenuItem("Alphawert...");
        m_miBrightnessContrast = new JMenuItem("Helligkeit/ Kontrast...");
        m_miSharpSoft = new JMenuItem("Scharf-/ Weichzeichnen...");
        m_miColorChannels = new JMenuItem("Farbkanle...");
        m_miIntensityFilter = new JMenuItem("Intensitts-Filter...");
        m_miZoomSelection = new JMenuItem("Ausschnitt vergrern...");
        m_miHistogramm = new JMenuItem("Histogram...");
        m_miInfo = new JMenuItem("Info...");

        m_miBackground.addActionListener(this);
        m_miOpen.addActionListener(this);
        m_miSave.addActionListener(this);
        m_miSaveAs.addActionListener(this);
        m_miPrint.addActionListener(this);
        m_miExit.addActionListener(this);
        m_miScale.addActionListener(this);
        m_miInvert.addActionListener(this);
        m_miAlpha.addActionListener(this);
        m_miBrightnessContrast.addActionListener(this);
        m_miSharpSoft.addActionListener(this);
        m_miColorChannels.addActionListener(this);
        m_miIntensityFilter.addActionListener(this);
        m_miZoomSelection.addActionListener(this);
        m_miHistogramm.addActionListener(this);
        m_miInfo.addActionListener(this);

        addWindowListener(new WindowAdapter()
        { public void windowClosing(WindowEvent e) {
              checkSave();
          }
        }) ;

        m_mbMainMenu.add(m_mFile);
        m_mbMainMenu.add(m_mEdit);
        m_mbMainMenu.add(m_mInfo);

        m_mFile.add(m_miBackground);
        m_mFile.add(m_miOpen);
        m_mFile.add(m_miSave);
        m_mFile.add(m_miSaveAs);
        m_mFile.add(m_miPrint);
        m_mFile.add(m_miExit);
        m_mEdit.add(m_miScale);
        m_mEdit.add(m_miInvert);
        m_mEdit.add(m_miAlpha);
        m_mEdit.add(m_miBrightnessContrast);
        m_mEdit.add(m_miSharpSoft);
        m_mEdit.add(m_miColorChannels);
        m_mEdit.add(m_miIntensityFilter);
        m_mEdit.add(m_miZoomSelection);
        m_mEdit.add(m_miHistogramm);
        m_mInfo.add(m_miInfo);

        m_miSave.setEnabled(false);
        m_miSaveAs.setEnabled(false);
        m_miPrint.setEnabled(false);
        m_mEdit.setEnabled(false);
        m_miAlpha.setEnabled(false);

        setJMenuBar(m_mbMainMenu);
        setVisible(true);
    }

    public void addChild(JInternalFrame child) {
        child.setDefaultCloseOperation(JInternalFrame.DISPOSE_ON_CLOSE);
        m_desk.add(child);
        child.setVisible(true);
    }

    private void checkSave() {
        if (!m_bSave) {
            int nReturn = JOptionPane.showConfirmDialog(this, "Wollen Sie die nderungen speichern?", "Frage", JOptionPane.YES_NO_CANCEL_OPTION);
            if (nReturn == JOptionPane.YES_OPTION) {
                saveFileAs();
                dispose();
                System.exit(0);
            }
            else if (nReturn == JOptionPane.NO_OPTION) {
                dispose();
                System.exit(0);
            }
            else return;
        } else {
            dispose();
            System.exit(0);
        }
    }

    // Actionevents
    public void actionPerformed(ActionEvent e) {
        JMenuItem miSource = (JMenuItem)e.getSource();

        if (miSource == m_miBackground) {
            openFile(m_BACKGROUND);
        }
        else if (miSource == m_miOpen) {
            openFile(m_FOREGROUND);
        }
        else if (miSource == m_miSave) {
            saveFile();
        }
        else if (miSource == m_miSaveAs) {
            saveFileAs();
        }
        else if (miSource == m_miPrint) {
            print();
        }
        else if (miSource == m_miExit) {
            checkSave();
        }
        else if (miSource == m_miScale) {
            ScaleDlg dlgScale = new ScaleDlg(this);
        }
        else if (miSource == m_miInvert) {
            invertImage();
        }
        else if (miSource == m_miAlpha) {
            AlphaDlg dlgAlpha = new AlphaDlg(this);
        }
        else if (miSource == m_miBrightnessContrast) {
            BrightContrastDlg dlgBright = new BrightContrastDlg(this);
        }
        else if (miSource == m_miSharpSoft) {
            SharpSoftDlg dlgSharpSoft = new SharpSoftDlg(this);
        }
        else if (miSource == m_miColorChannels) {
            ColorChannelDlg dlgColorChannel = new ColorChannelDlg(this);
        }
        else if (miSource == m_miIntensityFilter) {
            ThresholdDlg dlgThreshold = new ThresholdDlg(this);
        }
        else if (miSource == m_miZoomSelection) {
            createMagnifier();
        }
        else if (miSource == m_miHistogramm) {
            int[] nHistogramData = getHistogram(m_piForeground);
            HistogramDlg dlgHistogram = new HistogramDlg(this, nHistogramData);
        }
        else if (miSource == m_miInfo) {
            m_ssIntro.showFor(3000);
        }
    }

    // File I/O
    private void openFile(int nType) {
        if (!m_bSave && m_bOpen && nType == m_FOREGROUND) {
            int nReturn = JOptionPane.showConfirmDialog(this, "Wollen Sie die nderungen speichern?", "Frage", JOptionPane.YES_NO_CANCEL_OPTION);
            if (nReturn == JOptionPane.YES_OPTION) {
                saveFileAs();
            }
            else if (nReturn == JOptionPane.CANCEL_OPTION) {
                return;
            }
        }
        JFileChooser fcDlgOpen = new JFileChooser();
        fcDlgOpen.setFileFilter( new FileFilter() {
            public boolean accept( File f ) {
                return f.isDirectory() || f.getName().toLowerCase().endsWith(".jpg")
                || f.getName().toLowerCase().endsWith(".png")
                || f.getName().toLowerCase().endsWith(".bmp")
                || f.getName().toLowerCase().endsWith(".tiff");
            }
            public String getDescription() {
                return "Bilder";
            }
        });
        if (fcDlgOpen.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            File fImage = fcDlgOpen.getSelectedFile();
            if ( fImage.exists() && fImage.canRead() ) {
                m_sPathName = fImage.getAbsolutePath();
                if (nType == m_BACKGROUND) {
                    m_miAlpha.setEnabled(true);
                    try {
                        m_piBackground = JAI.create("fileload", m_sPathName);
                    } catch(Exception e) {
                        JOptionPane.showMessageDialog(this, "Sie mssen eine gltige Bilddatei whlen!", "Fehler", JOptionPane.ERROR_MESSAGE);
                        openFile(m_BACKGROUND);
                    }
                    m_idCanvasBack = new ImageDisplay(m_piBackground);
                    ImageWnd iw = new ImageWnd(this, "Hintergrund:  "+m_sPathName, m_idCanvasBack);
                }
                else if (nType == m_FOREGROUND) {
                    m_miSave.setEnabled(true);
                    m_miSaveAs.setEnabled(true);
                    m_miPrint.setEnabled(true);
                    m_mEdit.setEnabled(true);
                    try {
                        m_piForeground = JAI.create("fileload", m_sPathName);
                    } catch(Exception e) {
                        JOptionPane.showMessageDialog(this, "Sie mssen eine gltige Bilddatei whlen!", "Fehler", JOptionPane.ERROR_MESSAGE);
                        openFile(m_FOREGROUND);
                    }
                    m_idCanvasFore = new ImageDisplay(m_piForeground);
                    m_iwFore = new ImageWnd(this, "Vordergrund:  "+m_sPathName, m_idCanvasFore);
                    m_bOpen = true;
                }
            }
            else return;
        }
        else return;
    }

    private void saveFile() {
        char[] chExtension = new char[3];
        int nIndex = m_sPathName.lastIndexOf(".");
        String sExtension = m_sPathName.substring(nIndex + 1);
        JAI.create("filestore", m_piForeground, m_sPathName, sExtension.toUpperCase());
        m_bSave = true;
    }

    private void saveFileAs() {
        JFileChooser fcDlgSave = new JFileChooser();
        fcDlgSave.setFileFilter( new FileFilter() {
            public boolean accept( File f ) {
                return f.isDirectory() || f.getName().toLowerCase().endsWith(".jpg")
                || f.getName().toLowerCase().endsWith(".png")
                || f.getName().toLowerCase().endsWith(".bmp")
                || f.getName().toLowerCase().endsWith(".tiff");
            }
            public String getDescription() {
                return "Bilder";
            }
        });
        if (fcDlgSave.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            String sNewPath = fcDlgSave.getSelectedFile().getAbsolutePath();
            if (sNewPath.indexOf(".") == -1) {
                JOptionPane.showMessageDialog(this, "Sie mssen eine gltige Bilddatei-Endung (z.B. *.bmp) eingeben!", "Fehler", JOptionPane.ERROR_MESSAGE);
                saveFileAs();
            }
            int nIndex = sNewPath.lastIndexOf(".");
            String sExtension = sNewPath.substring(nIndex + 1);

            if (sExtension.toUpperCase().equals("JPG")) {
                saveJPEG(sNewPath);
            } else {
                try {
                    JAI.create("filestore", m_piForeground, sNewPath, sExtension.toUpperCase());
                } catch(Exception e) {
                    JOptionPane.showMessageDialog(this, "Sie mssen eine gltige Bilddatei-Endung (z.B. *.bmp) eingeben!", "Fehler", JOptionPane.ERROR_MESSAGE);
                    saveFileAs();
                }
                m_bSave = true;
            }
        }
        else return;
    }

    private void saveJPEG(String sDestination) {
        JPEGEncodeParam encodeParam = new JPEGEncodeParam();
        encodeParam.setQuality(0.1F);
        encodeParam.setWriteJFIFHeader(true);

        try {
            FileOutputStream out = new FileOutputStream(sDestination);
            ImageEncoder encoder = ImageCodec.createImageEncoder("JPEG", out, encodeParam);
            encoder.encode(m_piForeground);
            out.close();
        } catch (IOException e) {
        }
    }

    private void print() {
        PrinterJob pj = PrinterJob.getPrinterJob().getPrinterJob();
        pj.setPrintable(this);
        if (pj.printDialog()) {
            try{
                pj.print();
            }catch(Exception e){
            }
        }
    }

    public int print(Graphics g, PageFormat pageFormat, int pageIndex) throws PrinterException {
        if (pageIndex >= 1)
            return Printable.NO_SUCH_PAGE;
        Graphics2D g2d = (Graphics2D) g;
        g2d.translate(pageFormat.getImageableX(), pageFormat.getImageableY());
        AffineTransform at = new AffineTransform();
        at.translate(100, 100);
        g2d.drawRenderedImage(m_piForeground, at);
        return Printable.PAGE_EXISTS;
    }

    // Imageoperations
    private void invertImage() {
        m_piForeground = JAI.create("invert", m_piForeground);
        m_idCanvasFore.set(m_piForeground);
        m_bSave = false;
    }

    public void changeAlpha(int nAlphaValue) {
        Byte[] bandValues = new Byte[3];
        bandValues[0] = new Byte((byte) nAlphaValue);
        bandValues[1] = new Byte((byte) nAlphaValue);
        bandValues[2] = new Byte((byte) nAlphaValue);

        ParameterBlock pb = new ParameterBlock();
        pb.add((float) m_piForeground.getWidth());
        pb.add((float) m_piForeground.getHeight());
        pb.add(bandValues);
        PlanarImage piConstant = JAI.create("constant", pb);

        pb = new ParameterBlock();
        pb.addSource(m_piForeground);
        pb.addSource(m_piBackground);
        pb.add(piConstant);
        pb.add(null);
        pb.add(new Boolean(false));		// alpha used for both sources? dest colorchannels include alpha values?
        pb.add(CompositeDescriptor.NO_DESTINATION_ALPHA);	// no alpha band in destination, only 3 bands
        m_piTmp = JAI.create("composite", pb);

        m_idCanvasFore.set(m_piTmp);
    }

    public void scaleImage(int nScaleValue) {
        float fScaleValue = (float) nScaleValue;
        String sTitle = m_iwFore.getTitle();
        Point p = m_iwFore.getLocation();
        m_iwFore.dispose();

        ParameterBlock pb = new ParameterBlock();
        pb.addSource(m_piForeground);
        pb.add(fScaleValue / 10.0F);
        pb.add(fScaleValue / 10.0F);
        m_piTmp = JAI.create("scale", pb);

        m_idCanvasFore = new ImageDisplay(m_piTmp);
        m_iwFore = new ImageWnd(this, sTitle, m_idCanvasFore, p);
    }

    public void thresholdImage(double nHigh) {
        double low[] = new double[1];
        double high[] = new double[1];
        double map[] = new double[1];

        low[0]  = 0.0F;
        high[0] = nHigh;
        map[0]  = 0.0F; // use for pixels of intensity

        ParameterBlock pb = new ParameterBlock();
        pb.addSource(m_piForeground);
        pb.add(low);
        pb.add(high);
        pb.add(map);
        m_piTmp = JAI.create("threshold", pb);
        m_idCanvasFore.set(m_piTmp);
    }

    public void setColorChannel(int r, int g, int b) {
        int i;
        int nRed = r;
        int nGreen = g;
        int nBlue = b;
        byte lut[][] = new byte[3][256];

        // set color channel
        for (i = 0; i < 256; i++ ) {
            if (nRed == 1) r = i;
            else if (nGreen == 1) g = i;
            else if (nBlue == 1) b = i;
            lut[0][i] = (byte) r;
            lut[1][i] = (byte) g;
            lut[2][i] = (byte) b;
        }
        LookupTableJAI lutNew = new LookupTableJAI(lut);

        ParameterBlock pb = new ParameterBlock();
        pb.addSource(m_piForeground);
        pb.add(lutNew);
        m_piTmp = JAI.create("lookup", pb);
        m_idCanvasFore.set(m_piTmp);
    }

    public void setBrightness(int b) {
        byte[] lutData = new byte[256];

        for ( int i = 0; i < 256; i++ ) {
            lutData[i] = clampByte(i+b);
        }
        LookupTableJAI lutNew = new LookupTableJAI(lutData);

        ParameterBlock pb = new ParameterBlock();
        pb.addSource(m_piForeground);
        pb.add(lutNew);
        m_piTmp = JAI.create("lookup", pb);
        m_idCanvasFore.set(m_piTmp);
    }

    private byte clampByte(int v) {
        if ( v > 255 ) {
            return (byte)255;
        } else if ( v < 0 ) {
            return (byte)0;
        } else {
            return (byte)v;
        }
    }

    public void setContrast(int nLow, int nHigh) {
        int bands = m_piForeground.getSampleModel().getNumBands();
        double rmin, rmax, slope, y_int;
        double low = (double) nLow;
        double high = (double) nHigh;

        // use a lookup table for rescaling
        if (high != low) {
            slope = 256.0 / (high - low);
            y_int = 256.0 - slope * high;
        } else {
            slope = 0.0;
            y_int = 0.0;
        }
        byte lut[][] = new byte[bands][256];

        for (int i = 0; i < 256; i++) {
            for (int j = 0; j < bands; j++) {
                int value = (int) (slope * i + y_int);
                if (value < (int) low) {
                    value = 0;
                } else if (value > (int) high) {
                    value = 255;
                } else {
                    value &= 0xFF;
                }
                lut[j][i] = (byte) value;
            }
        }
        LookupTableJAI lookup = new LookupTableJAI(lut);
        ParameterBlock pb = new ParameterBlock();
        pb.addSource(m_piForeground);
        pb.add(lookup);
        m_piTmp = JAI.create("lookup", pb);
        m_idCanvasFore.set(m_piTmp);
    }

    public void setKernel(float[] nKernelValues) {
        float nSum = 0.0F;
        for (int i = 0; i < nKernelValues.length; i++) {
            nSum += nKernelValues[i];
        }
        if (nSum > 0.0F) {
            for ( int i = 0; i < nKernelValues.length; i++ ) {
                nKernelValues[i] = nKernelValues[i] / nSum;
            }
        }

        KernelJAI kernelJAI = new KernelJAI(3, 3, nKernelValues);
        ParameterBlock pb = new ParameterBlock();
        pb.addSource(m_piForeground);
        pb.add(kernelJAI);
        m_piTmp = JAI.create("convolve", pb);
        m_idCanvasFore.set(m_piTmp);
    }

    public int[] getHistogram() {
        return getHistogram(m_piForeground);
    }

    private int[] getHistogram(PlanarImage image) {
        // set up the histogram
        int[] bins = {256};
        double[] low = {0.0D};
        double[] high = {256.0D};

        ParameterBlock pb = new ParameterBlock();
        pb.addSource(image);
        pb.add(null);   // ROI
        pb.add(1);      // Sampling
        pb.add(1);      // Periods
        pb.add(bins);
        pb.add(low);
        pb.add(high);

        m_piTmp = JAI.create("histogram", pb);
        Histogram histogram = (Histogram) m_piTmp.getProperty("histogram");

        // get 1 band histogram contents
        int[] nHistogramData = new int[histogram.getNumBins(0)];
        for ( int i = 0; i < histogram.getNumBins(0); i++ ) {
            nHistogramData[i] = histogram.getBinSize(0, i);
        }
        return nHistogramData;
    }

    public void setZoomed(RenderedOp roZoomed) {
        Point pLoc = new Point(100, 100);
        if (m_iwZoom != null && !m_iwZoom.isClosed()) {
            pLoc = m_iwZoom.getLocation();
            m_iwZoom.dispose();
        }
        m_piTmp = roZoomed;
        ParameterBlock pb = new ParameterBlock();
        pb.addSource(m_piTmp);
        pb.add(3.0F);
        pb.add(3.0F);
        m_piTmp = JAI.create("scale", pb);

        m_idCanvasZoom = new ImageDisplay(m_piTmp);
        m_iwZoom = new ZoomWnd(this, m_idCanvasZoom, pLoc);
    }

    public void createMagnifier() {
        int nSize = m_piForeground.getWidth() / 5;
        m_magZoom = new Magnifier(this);
        m_magZoom.setSource(m_idCanvasFore);
        m_magZoom.setMagnification(3.0F);
        m_magZoom.setSize(nSize, nSize);
        m_magZoom.setLocation(0, 0);
        m_magZoom.setBorder(new LineBorder(Color.GREEN, 1));
        m_idCanvasFore.add(m_magZoom);
        m_iwFore.repaint();
    }

    public void destroyMagnifier() {
        m_idCanvasFore.remove(m_magZoom);
        m_iwZoom.dispose();
        m_iwFore.repaint();
    }

    public void setImage() {
        m_piForeground = m_piTmp;
        m_bSave = false;
    }

    public void setZoomImage() {
        m_piForeground = m_piTmp;
        String sTitle = m_iwFore.getTitle();
        Point p = m_iwFore.getLocation();
        m_iwFore.dispose();

        m_idCanvasFore = new ImageDisplay(m_piForeground);
        m_iwFore = new ImageWnd(this, sTitle, m_idCanvasFore, p);

        m_iwZoom.dispose();
        m_bSave = false;
    }

    public void rollBack() {
        m_idCanvasFore.set(m_piForeground);
    }

    public void rollScaleBack() {
        String sTitle = m_iwFore.getTitle();
        Point p = m_iwFore.getLocation();
        m_iwFore.dispose();
        m_idCanvasFore = new ImageDisplay(m_piForeground);
        m_iwFore = new ImageWnd(this, sTitle, m_idCanvasFore, p);
    }

    // Mainmethod
    public static void main(String[] args) {
        PicEdit peMainFrame = new PicEdit(1024, 750);
        SplashScreen ssIntro = new SplashScreen(peMainFrame);
        ssIntro.showFor(3000);
    }
}