import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.util.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.media.jai.*;
import javax.media.jai.operator.*;

public class SharpSoftDlg extends JInternalFrame implements KeyListener {
    private JTextField[][] m_tfKernelValues;
    private PicEdit m_frmParent;
    
    public SharpSoftDlg(final PicEdit frmParent) {
        super("Scharf-/ Weichzeichnen...", false, true, false, true);
        this.m_frmParent = frmParent;
        getContentPane().setLayout(new BorderLayout());
        Point parentLoc = frmParent.getLocation();
        setLocation(parentLoc.x + 100, parentLoc.y + 100);
        
        JPanel panelKernelValues = new JPanel();
        panelKernelValues.setLayout(new GridLayout(3, 3, 0, 0));
        m_tfKernelValues = new JTextField[3][3];
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 3; j++) {
                m_tfKernelValues[i][j] = new JTextField();
                m_tfKernelValues[i][j].setText("1.0");
                m_tfKernelValues[i][j].addKeyListener(this);
                panelKernelValues.add(m_tfKernelValues[i][j]);
            }
        }
        
        JPanel panelButtons = new JPanel();
        JButton btnDo = new JButton("Anwenden");
        JButton btnUnDo = new JButton("Verwerfen");
        JButton btnSoft = new JButton("Weich");
        JButton btnSharp = new JButton("Scharf");
        panelButtons.add(btnDo);
        panelButtons.add(btnUnDo);
        panelButtons.add(btnSharp);
        panelButtons.add(btnSoft);
        
        // Eventhandlers...
        btnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.setImage();
            }
        });
        btnUnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.rollBack();
            }
        });
        btnSharp.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                float[] nKernelValues = new float[9];
                nKernelValues[0] =-1.0F; nKernelValues[1] =-1.0F; nKernelValues[2] =-1.0F;
                nKernelValues[3] =-1.0F; nKernelValues[4] = 8.0F; nKernelValues[5] =-1.0F;
                nKernelValues[6] =-1.0F; nKernelValues[7] =-1.0F; nKernelValues[8] =-1.0F;
                for ( int i = 0; i < 3; i++ ) {
                    for ( int j = 0; j < 3; j++ ) {
                        m_tfKernelValues[i][j].setText("" + nKernelValues[3*i+j]);
                    }
                }
                frmParent.setKernel(nKernelValues);
            }
        });
        btnSoft.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                float[] nKernelValues = new float[9];
                nKernelValues[0] = 1.0F; nKernelValues[1] = 2.0F; nKernelValues[2] = 1.0F;
                nKernelValues[3] = 2.0F; nKernelValues[4] = 4.0F; nKernelValues[5] = 2.0F;
                nKernelValues[6] = 1.0F; nKernelValues[7] = 2.0F; nKernelValues[8] = 1.0F;
                for ( int i = 0; i < 3; i++ ) {
                    for ( int j = 0; j < 3; j++ ) {
                        m_tfKernelValues[i][j].setText("" + nKernelValues[3*i+j]);
                    }
                }
                frmParent.setKernel(nKernelValues);
            }
        });
        
        //Put everything together
        getContentPane().add(new JLabel("Floatwerte fr Kernel:"), BorderLayout.NORTH);
        getContentPane().add(panelKernelValues, BorderLayout.CENTER);
        getContentPane().add(panelButtons, BorderLayout.SOUTH);
        pack();
        frmParent.addChild(this);
    }
    
    public void keyPressed(KeyEvent e) {
        float[] nKernelValues = new float[9];
        
        if (e.getKeyCode() == KeyEvent.VK_ENTER) {
            for ( int i = 0; i < 3; i++ ) {
                for ( int j = 0; j < 3; j++ ) {
                    try {
                        nKernelValues[3*i+j] = Float.parseFloat(m_tfKernelValues[i][j].getText());
                    } catch(NumberFormatException nfe) {
                        JOptionPane.showMessageDialog(this, "Sie mssen Float-Werte der Form 'Zahl.Zahl' eingeben!", "Fehler", JOptionPane.ERROR_MESSAGE);
                        return;
                    }
                }
            }
            m_frmParent.setKernel(nKernelValues);
        }
    }
    
    public void keyReleased(KeyEvent e) {
    }
    
    public void keyTyped(KeyEvent e) {
    }
}